<?
###################################
#                                 #
# Btsource torrentlist functions  #
# Written 20/08/05                #
#                                 #
###################################

function torrent_list($whe, $ord, $dead=''){
	
	//firstly load the globals...
	global $_CFG, $u;
	
	//page linker system
	list($page_list,$sourt,$page) = explode('_',linker());
	
	//main query
	$query = 'SELECT t.torrentid, t.name, t.filesize, t.catid, t.submitter, t.submit_date, t.votes, t.score, t.info_hash, t.hidden,
			xf.fid, xf.seeders, xf.leechers, xf.completed, 
			c.name AS cname, c.catid,
			c2.name AS c2name, c2.catid AS cid,
			u.username, u.class,
			ug.openhtml, ug.closehtml
			FROM '.SQL_PREFIX.'torrents t
			LEFT JOIN '.SQL_PREFIX.'cats c ON c.catid=t.catid
			LEFT JOIN '.SQL_PREFIX.'cats c2 ON c2.catid=t.subcat
			INNER JOIN '.X_SQL_PREFIX.'files xf ON xf.info_hash=t.info_hash
			INNER JOIN '.SQL_PREFIX.'users u ON u.uid=t.submitter
			INNER JOIN '.SQL_PREFIX.'usergroups ug ON ug.gid=u.class';
	
	//can we see hidden torrents?
	if($u['can_moderate'] != '1' || $u['admin_access'] != '1'){
		$mod = ' AND hidden != 1';
	}	
	
	//display dead torrents?
	if($dead != '1'){
		$ddead = ' AND t.dead != 1';
	}
	//main query
	$sql = cmysql_query($query.$whe.$mod.$ddead.$ord.$sourt);
	
	//count query
	$num = mysql_num_rows(cmysql_query($query.$whe.$mod.$ddead.$order));
	
	//can we use the modcp? if so load it
	if($u['can_moderate'] == '1' || $u['can_delete'] == '1' || $u['admin_access'] == '1'){
		//load the modcp
		$ismod = modcp();
		$mod = '1';
		$td = '<td colspan="2">Torrent</td>';
	}else{
		$td = '<td>Torrents</td>';
	}
	//output the main tables head :)
	echo'<table class="tlist"><tr class="thead">'.$td;
	if($_CFG['monitor_ratio'] != '0'){
		echo'<td>Wate</td>';
	}
	echo'<td>Size</td><td>S</td><td>L</td><td>C</td><td>Submitter</td><td>Submit Date</td><td>Category</td><td>Score</td></tr>';
	
	//make sure we have some torrents before trying to list them ;-)
	if($num > 0){
		while($row = mysql_fetch_array($sql)){
			
			//first thing todo is calculate the score 
			if($row['votes'] === '0'){
				$score = '0';
			}else{
				$score = round($row['score']/$row['votes'], 1);
			}
			//are the rows hidden torrents?
			if($row['hidden'] == '1'){
				echo'<tr class="hidden">';
			}else{
				echo'<tr class="row1">';
			}
			//are we a mod (output the checkbox)
			if($mod == '1'){
				echo'<td align="center"><input type="checkbox" name="'.$row['torrentid'].'_-_'.$row['fid'].'" value="'.$row['torrentid'].'_-_'.$row['fid'].'"></td>';
			}
			echo'<td><a href="'.$_CFG['boardurl'].'/?page=torrentinfo&amp;tid='.$row['torrentid'].'" title="'.$row['name'].'">'.torrent_truncate($row['name'], $_CFG['torrent_namelen']).'</a></td>';
			//do we have watetimes enabled?
			if($_CFG['monitor_ratio'] == '1'){
				$w1 = $row['submit_date'] - time();
				$w2 = $w1 - $u['watetime'];
				if($w2 < '0'){
					$w2 = '0';
				}
				echo'<td>'.round($w2).'h</td>';
			}
			
			//Are we displaying dead torrents?
			if($dead == '1'){
				$seedrow = '<td colspan="2">Torrent Dead</td>';
			}else{
				$seedrow = '<td><b><font color="green">'.$row['seeders'].'</font></b></td>
			<td><b><font color="red">'.$row['leechers'].'</font></b></td>';
			} 
			//back onto the regula stuff :/
			echo'<td>'.byte2mbyte($row['filesize']).'</td>
			'.$seedrow.'
			<td><b>'.$row['completed'].'</b></td>
			<td>'.$row['openhtml'].$row['username'].$row['closehtml'].'</td>
			<td>'.date("d-F H:i", $row['submit_date']).'</td>
			<td><a href="'.$_CFG['boardurl'].'/?page=torrents&amp;catid='.$row['catid'].'" title="'.$row['cname'].'">'.$row['cname'].'</a>';
			//are we using subcats?
			if($_CFG['use_subcats'] == '1'){
				echo' -- <a href="'.$_CFG['boardurl'].'/?page=torrents&amp;catid='.$row['catid'].'&amp;subcat='.$row['cid'].'" title="'.$row['c2name'].'">'.$row['c2name'].'</a>';
			}
			//w00t the score
			echo'</td><td>'.$score.'\5</td>';
		}

		if(isset($_GET['page'])){
			//page linker, BUT only if were NOT on the home page 
			echo'<div align="center"><table><tr align="center">';
			$getstr = '';
			foreach($_GET as $ind => $val){
				if($ind !== 'tl_page'){
					if(strlen($getstr)==0){
						$getstr = $ind.'='.$val;
					}else{
						$getstr .='&'.$ind.'='.$val;
					}
				}
			}
			echo'<td><b>Pages:</b></td>';
			for($x=1;$x<=ceil($num/$_CFG['max_list_torrents']);$x++){
				if($x==$page){
					echo'<td>['.$page.']</td>';
				}else{
					echo'<td><a href="'.$_CFG['boardurl'].'/'.get_form_url().'&amp;tl_page='.$x.'" title="'.$x.'">'.$x.'</a></td>';
				}
			}
			echo'</tr>';
		}
	}else{
		echo'<td colspan="9" align="center">NO TORRENTS FOUND</td></tr>';
	}
	if($ismod == 1){
		echo'</table></form>';
	}
	else 
	{
		echo'</table>';
	}
}

function modcp()
{
	global $_CFG, $u, $lang;
			echo'<div class="header"><a href="javascript:toggleLayer(\'modcp\')"><div align="center">ModCP</div></a>
		<div id="modcp" class="hide">
		<form name="modcp" method="POST" action="'.$_CFG['boardurl'].'/?page=modcp&amp;op=1">
		<input type="hidden" name="redirect" value="'.get_form_url().'">
		<table class="tlist"><tr class="thead"><td>Mod Options</td><td>Message from the admins</td></tr><tr><td>';
		if($u['can_delete'] == '1'){
			echo'<input type="radio" name="mod" value="1">Mass Delete Torrents<br />';
		}
		if($u['can_moderate'] == '1'){
			echo'<input type="radio" name="mod" value="2">Mass Approve Torrents<br />
			<input type="radio" name="mod" value="3">Mass Hide Torrents <br />
			<input type="radio" name="mod" value="4">Move torrents to...<select name="move">'.cat_list().'</select>';
		}
		echo'</td><td>'.$_CFG['mod_message'].'</td></tr></table><input type="submit" name="submit" value="Do It"></table></div></div>';
				
		return 1;
}
			