<?php
###############################################
#                                             #
# BTsource torrent list page  				  #
# Re-Writtern 1/08/05						  #
#								              #
###############################################

/*-------------
# load the torrent list libary
#-------------*/
require_once('./pages/misc/tlist.lib.php');

//can we view torrents?
if($u['can_view_torrent'] != '1'){
	echo'<div class="header">'.$lang['global_error'].'</div>'.$lang['global_noviewtorrent'];
}
else
{
	/*-------------------
	# Are we after a specific category?
	#------------------*/
	if (!isset($_GET['catid']) || !cat_valid($_GET['catid'])){
		
		//no cats selected so just a general query 
		torrent_list('',' ORDER BY t.torrentid DESC');
	}
	else 
	{
		$catid = addslashes(stripslashes($_GET['catid']));
		
		/*------------------
		# So were after a set cat, how about sub-cat?
		#-----------------*/
		if (isset($_GET['subcat']) && cat_valid($_GET['subcat'])){

			//both are set, lets include subcats
			$subcatid = addslashes(stripslashes($_GET['subcat']));
			
			//list the avlaible subcats
			torrents_listsubcats($catid);
			$string = ' WHERE t.catid = '.$catid.' AND t.subcat = '.$subcatid;
			torrent_list($string, ' ORDER BY t.torrentid DESC');
		}
		else
		{
			//ok so were not after a subcat...
			$string = ' WHERE t.catid = '.$catid;
			if($_CFG['use_subcats'] == '1'){
				torrents_listsubcats($catid);
			}
			torrent_list($string, ' ORDER BY t.torrentid DESC');
		}
	}
}

/*-------------------
# This function lists all the avlaible subcats for a given parent
#------------------*/

function torrents_listsubcats($catid)
{
     // The subcat is not set or invalid
     $sql = 'SELECT `catid`,`name` FROM `'.SQL_PREFIX.'cats` WHERE `parent` = \''.$catid.'\' ORDER BY `name` ASC';
     $res = @cmysql_query($sql,$db);

     $i=0;
     $caturl = './?page=torrents&catid='.$catid;
     echo '<div><a href="'.$caturl.'">'.torrents_catname($catid).'</a></div>';
     while(list($scatid,$name) = @mysql_fetch_row($res))
     {
          $url = './?page=torrents&catid='.$catid.'&subcat='.$scatid;
          echo '<div class="head">-&#187;<a href="'.$url.'"># '.stripslashes($name).'</a></div>';
          $i++;
     }
     if ($i==0)
     {
          echo '<div><b>There are no subcategories for this category!</b></div>';
     }
}

/*------------------
# This function gets the name 
# for the subcats for a given parent
#-----------------*/
function torrents_catname($catid)
{
     $catid = addslashes(stripslashes($catid));
     $sql = 'SELECT `name` FROM `'.SQL_PREFIX.'cats` WHERE `catid` = \''.$catid.'\'';
     $res = @cmysql_query($sql);

     list($name) = @mysql_fetch_row($res);
     return stripslashes($name);
}

/*---------------
# This function checks the cats sent
# to it to make sure they actually exist
#---------------*/
function cat_valid($cid){
	$cid = addslashes(stripslashes($cid));
	$res = cmysql_query('SELECT `catid` FROM `'.SQL_PREFIX.'cats` WHERE `catid` = \''.$cid.'\'');
	if(@mysql_num_rows($res)>0)
	{
		return true;
	}
	else 
	{
		return false;
	}
}
?>
			