<?php

// If you disable rss, it will give the following error
if($_CFG['enable_rss'] != '1') {
	echo "<b>Error</b>: The site's administrator has decided not to enable RSS support.";
	die();
}

// Output the xml header
header('Content-type: text/xml');

// Function to cleanup non-standard characters
function strictify($string) {
	$fixed = htmlspecialchars($string, ENT_QUOTES);
	
	$trans_array = array();
	for($i = 127; $i < 255; $i++) {
		$trans_array[chr($i)] = "&#" . $i . ";";
	}
	$really_fixed = strtr($fixed, $trans_array);
	
	return $really_fixed;
}

// Start the feed
?>
<rss version="2.0">
	<channel>
	<title><?php print $_CFG['boardname']; ?>'s Latest Torrents</title>
	<link><?php print $_CFG['boardurl']; ?></link>
	<description></description>
<?
// Setup the query
$sql = 'SELECT t.torrentid,
	t.name,
	t.downloaded,
	t.submit_date,
	t.description,
	xf.seeders,
	xf.leechers,
	xf.completed
	FROM '.SQL_PREFIX.'torrents t
		inner join '.X_SQL_PREFIX.'files xf ON xf.info_hash=t.info_hash
		WHERE t.hidden != 1 AND t.dead != 1
		order by t.torrentid desc LIMIT ' . $_CFG['max_list_torrents'] . '';

// Run the query and grab the data
$res = mysql_query($sql) or die(mysql_error());
while ($row = mysql_fetch_array($res)) {
	// Clean up the variables
	$row['torrent_name'] = strictify($row['name']);
	$added = date("D, d M Y H:i:s  O", $row['submit_date']);
	$tid = $row['torrentid'];
	$seed = sprintf("%02d", $row['seeders']);
	$leech = sprintf("%02d", $row['leechers']);
	$com = sprintf("%02d", $row['completed']);
	$post = strictify(strip_tags($row['description']));

// Output to browser
?>
		<item>
			<title><?php print htmlentities($row['name'],ENT_QUOTES);?></title>
			<?php if($_CFG['rss_download'] == '1'){ ?>
			<link>"<?php print htmlentities($_CFG['boardurl'],ENT_QUOTES); print "/download.php?tid=$tid"; ?></link>
			<?php }else{ ?>
			<link><?php print htmlentities($_CFG['boardurl'],ENT_QUOTES); print "/?page=torrentinfo&amp;tid=$tid"; ?></link>
			<?php } ?>
			<guid><?php print htmlentities($_CFG['boardurl'],ENT_QUOTES); print "/?page=torrentinfo&amp;tid=$tid"; ?></guid>
			<description><![CDATA[<?php print "$post\n<div>[$seed seeder(s), $leech leecher(s), $com completed]</div>";?>]]></description>
			<pubDate><?php print $added; ?></pubDate>
		</item>
<?php
}

// Close the RSS feed and end the page
?>
	</channel>
</rss>

